package generated.eTicket.server.eTicketServer;

/**
 * Generated Class
 * 
 */

public class BuyInfo implements PlainData, Codeable {

	private CCInfo ccInfo;

	private TicketInfo ticketInfo;

	private ID cardID;

	private Nonce transactionId;

	public BuyInfo(CCInfo ccInfo, TicketInfo ticketInfo, ID cardID,
			Nonce transactionId) {

		this.ccInfo = ccInfo;
		this.ticketInfo = ticketInfo;
		this.cardID = cardID;
		this.transactionId = transactionId;

	}

	public BuyInfo() {

		ccInfo = new CCInfo();
		ticketInfo = new TicketInfo();
		cardID = new ID();
		transactionId = new Nonce();

	}

	public CCInfo getCcInfo() {
		return ccInfo;
	}

	public TicketInfo getTicketInfo() {
		return ticketInfo;
	}

	public ID getCardID() {
		return cardID;
	}

	public Nonce getTransactionId() {
		return transactionId;
	}

	public void setCcInfo(CCInfo ccInfo) {
		this.ccInfo = ccInfo;
		this.ccInfo.setCCHolderName(ccInfo.getCCHolderName());
		this.ccInfo.setCCSecNumber(ccInfo.getCCSecNumber());
		this.ccInfo.setCCNumber(ccInfo.getCCNumber());
		this.ccInfo.setCCType(ccInfo.getCCType());
		this.ccInfo.setCCExpDate(ccInfo.getCCExpDate());
	}
	public void setTicketInfo(TicketInfo ticketInfo) {
		this.ticketInfo = ticketInfo;
		this.ticketInfo.setDeparture(ticketInfo.getDeparture());
		this.ticketInfo.setDestination(ticketInfo.getDestination());
		this.ticketInfo.setTrainClass(ticketInfo.getTrainClass());
		this.ticketInfo.setExpiration(ticketInfo.getExpiration());
	}
	public void setCardID(ID cardID) {
		this.cardID = cardID;
		this.cardID.setId(cardID.getId());
	}
	public void setTransactionId(Nonce transactionId) {
		this.transactionId = transactionId;
		this.transactionId.setNonce(transactionId.getNonce());
	}

	public byte getCode() {
		return Code.BUYINFO;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(BuyInfo other) {
		if (!this.ccInfo.equals(other.ccInfo))
			return false;
		if (!this.ticketInfo.equals(other.ticketInfo))
			return false;
		if (!this.cardID.equals(other.cardID))
			return false;
		if (!this.transactionId.equals(other.transactionId))
			return false;
		return true;
	}

	public void copy(BuyInfo from) {
		this.ccInfo.copy(from.ccInfo);
		this.ticketInfo.copy(from.ticketInfo);
		this.cardID.copy(from.cardID);
		this.transactionId.copy(from.transactionId);
	}

	public BuyInfo copy() {
		BuyInfo object = new BuyInfo();
		object.copy(this);
		return object;
	}

}
