package generated.eTicket.server.eTicketServer;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.swing.JOptionPane;
import javax.xml.ws.Endpoint;
import javax.xml.ws.wsaddressing.W3CEndpointReference;
import com.sun.net.httpserver.HttpsServer;

/**
 *
 * @author Marian Borek
 */
@WebService
public class ETicketServerStatefulManager {

	private PrivateKey signKey;

	private PublicKey certVerifyKey;

	private PrivateKey privateKeyServer;

	private byte state;

	private Endpoint endpoint;
	private HttpsServer httpsServer;
	private Integer requestTimeout = new Integer(1000 * 60 * 10);
	private boolean setRequestTimeout = true;

	public ETicketServerStatefulManager() throws java.lang.Exception {

		signKey = new PrivateKey();
		certVerifyKey = new PublicKey();
		privateKeyServer = new PrivateKey();
		state = StateService.IDLE;

	}

	public ETicketServerStatefulManager(PublicKey certVerifyKey,
			PrivateKey privateKeyServer, PrivateKey signKey, byte state)
			throws java.lang.Exception {

		this.certVerifyKey = certVerifyKey;
		this.privateKeyServer = privateKeyServer;
		this.signKey = signKey;
		this.state = state;

	}

	@WebMethod
	public synchronized W3CEndpointReference getReference()
			throws java.lang.Exception {
		ETicketServer server = new ETicketServer();

		server.setSignKey(signKey);

		server.setCertVerifyKey(certVerifyKey);

		server.setPrivateKeyServer(privateKeyServer);

		server.setState(state);

		if (setRequestTimeout) {
			ETicketServer.manager.setTimeout(requestTimeout, null);
			setRequestTimeout = false;
		}

		//Die URL ist nur fr Standalone notwendig. 
		//Wenn die WebServices auf einem richtigen Server deployed werden, 
		//dann kann die URL weggelassen werden.
		W3CEndpointReference reference = ETicketServer.manager.export(
				W3CEndpointReference.class,
				"http://localhost:8000/ETicketServerService", server);

		return reference;
	}

	public void startService() throws java.lang.Exception {

		endpoint = Endpoint.publish(
				"http://localhost:8001/ETicketServerStatefulManagerService",
				this);

	}
	public void stopService() {
		endpoint.stop();

	}
	public static void main(String[] args) throws java.lang.Exception {
		ETicketServerStatefulManager s = new ETicketServerStatefulManager();
		s.startService();
		JOptionPane.showMessageDialog(null, "Server beenden");
		s.stopService();
	}

}
