package generated.eTicket.terminal.inspectorDevice;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import java.util.ArrayList;
@XmlAccessorType(XmlAccessType.FIELD)
public class ListOfTicket implements Codeable, PlainData, SignData {

	private short size;
	public Ticket[] elems;
	private short index;

	public ListOfTicket() {
		this.size = 0;
		elems = new Ticket[size];
		for (short i = 0; i < elems.length; i++)
			elems[i] = new Ticket();
	}

	public ListOfTicket(short size) {
		this.size = size;
		elems = new Ticket[size];
		for (short i = 0; i < elems.length; i++)
			elems[i] = new Ticket();
	}

	//don't use this function if you use get(key), set(value) or containsKey(key)

	public void add(Ticket e) {
		elems[index++].copy(e);
	}

	//returns the number of elems that are stored in the list
	public short size() {
		return index;
	}

	public boolean hasFree() {
		return index < elems.length;
	}

	public short index() {
		return index;
	}

	//**************************************************

	public boolean isEmpty() {
		return index == 0;
	}

	public void clear() {
		index = 0;
	}

	public boolean contains(Ticket e) {
		for (short i = 0; i < index; i++) {
			if (elems[i].equals(e)) {
				return true;
			}
		}
		return false;
	}

	public void remove(Ticket e) {
		removeIndex(containsAndIndex(e));
	}

	public void removeAll(Ticket e) {
		removeAllIndex(containsAndIndex(e), e);
	}

	public Ticket at(short index) {
		return elems[index];
	}

	public void copy(ListOfTicket from) {
		this.index = from.index;
		for (int i = 0; i < from.index; i++) {
			this.elems[i].copy(from.elems[i]);

		}

	}

	public Ticket get(ID key) throws TerminalException {
		for (short i = 0; i < index; i++)
			if (elems[i].getId().equals(key)) {
				Ticket value = new Ticket();
				value.copy(elems[i]);
				return value;
			}
		throw new TerminalException("List: key does not exist");
	}

	public void set(Ticket value) {

		Ticket item;

		try {
			item = get(value.getId());
			remove(item);
		} catch (TerminalException e) {
		}
		add(value);

	}
	public Boolean containsKey(ID key) {
		try {
			get(key);
			return true;
		} catch (TerminalException e) {
			return false;
		}
	}

	public Boolean remove(ID key) {
		try {
			remove(get(key));
			return true;
		} catch (TerminalException e) {
			return false;
		}
	}

	//****************************************************

	private short containsAndIndex(Ticket e) {
		for (short i = 0; i < index; i++) {
			if (elems[i].equals(e)) {
				return i;
			}
		}
		return -1;
	}

	private void removeIndex(short ind) {
		if (ind >= 0 && ind < index) {
			for (short i = ind; (short) (i + 1) < index; i++) {
				elems[i].copy(elems[(short) (i + 1)]);
			}
			index--;
		}
	}

	private void removeAllIndex(short ind, Ticket e) {
		if (ind >= 0) {
			short i = ind;
			short found = 1;
			for (short j = (short) (ind + 1); j < index; j++) {
				if (!elems[j].equals(e)) {
					elems[i++].copy(elems[j]);
				} else {
					found++;
				}
			}
			index -= found;
		}
	}

	public boolean equals(ListOfTicket o) {
		if (size != o.size)
			return false;
		for (int i = 0; i < o.size; i++)
			if (!elems[i].equals(o.elems[i]))
				return false;
		return true;
	}

	public byte getCode() {
		return Code.LISTOFTICKET;
	}

}
