package generated.eTicket.terminal.inspectorDevice;

/**
 * Generated Class
 * 
 */

public class TicketInfo implements Codeable {

	private String departure;

	private String destination;

	private int trainClass;

	private String expiration;

	public TicketInfo() {

		departure = new String();
		destination = new String();
		trainClass = 0;
		expiration = new String();

	}

	public TicketInfo(String departure, String destination, int trainClass,
			String expiration) {

		this.departure = departure;
		this.destination = destination;
		this.trainClass = trainClass;
		this.expiration = expiration;

	}

	public TicketInfo(byte[] departure, byte[] destination, int trainClass,
			byte[] expiration) {
		this.departure = Coding.getInstance().byteToString(departure);
		this.destination = Coding.getInstance().byteToString(destination);
		this.trainClass = trainClass;
		this.expiration = Coding.getInstance().byteToString(expiration);

	}

	public String getDeparture() {
		return departure;
	}

	public String getDestination() {
		return destination;
	}

	public int getTrainClass() {
		return trainClass;
	}

	public String getExpiration() {
		return expiration;
	}

	public void setDeparture(String departure) {

		if (!Coding.getInstance().isValidCardString(departure))
			System.err.println("Encoded string " + departure
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.departure = departure;
	}
	public void setDeparture(byte[] departure) {
		setDeparture(Coding.getInstance().byteToString(departure));
	}

	public void setDestination(String destination) {

		if (!Coding.getInstance().isValidCardString(destination))
			System.err.println("Encoded string " + destination
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.destination = destination;
	}
	public void setDestination(byte[] destination) {
		setDestination(Coding.getInstance().byteToString(destination));
	}

	public void setTrainClass(int trainClass) {
		this.trainClass = trainClass;
	}

	public void setExpiration(String expiration) {

		if (!Coding.getInstance().isValidCardString(expiration))
			System.err.println("Encoded string " + expiration
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.expiration = expiration;
	}
	public void setExpiration(byte[] expiration) {
		setExpiration(Coding.getInstance().byteToString(expiration));
	}

	public byte getCode() {
		return Code.TICKETINFO;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(TicketInfo other) {
		if (!this.departure.equals(other.departure))
			return false;
		if (!this.destination.equals(other.destination))
			return false;
		if (this.trainClass != other.trainClass)
			return false;
		if (!this.expiration.equals(other.expiration))
			return false;
		return true;
	}

	public void copy(TicketInfo from) {
		this.departure = from.departure;
		this.destination = from.destination;
		this.trainClass = from.trainClass;
		this.expiration = from.expiration;
	}

	public TicketInfo copy() {
		TicketInfo object = new TicketInfo();
		object.copy(this);
		return object;
	}

}
