package generated.eTicket.terminal.userDevice;

//import swt.simulation.SmartCardSimulation;
import swt.terminal.HandleResult;
import swt.util.ByteArray;
import swt.util.HexString;
import de.uniaugsburg.swt.javacard.terminalinterface.SWTReader;
import de.uniaugsburg.swt.javacard.terminalinterface.SWTReaderException;
import javax.xml.ws.BindingProvider;

import generated.eTicket.terminal.userDevice.eTicketServerStubs.*;
import generated.eTicket.terminal.userDevice.eTicketServerStatefulManagerStubs.*;

public class UserDevice {

	private byte state;

	private Secret pin;

	private java.util.Map<String, Object> statefulServices = java.util.Collections
			.synchronizedMap(new java.util.TreeMap<String, Object>());

	private Userinterface userinterface;
	public void setUserinterface(Userinterface u) {
		this.userinterface = u;
	}

	// saved prev message
	public byte[] prevMsg;
	public Usermessage prevUMsg;

	public final Gate dummyGate = new Gate() {
		@Override
		public void callConstraints() {
			/* do nothing */
		}

		@Override
		public byte[] transmit(UserDevice terminal, byte[] apdu, int port)
				throws TerminalException, SWTReaderException {
			return terminal.transmit(apdu, port);
		}

		@Override
		public void finishProtocol(UserDevice terminal) {
			/* do nothing */
		}

	};
	public Gate currentGate = dummyGate;

	/**
	 * Resets the current gate to a default dummy gate
	 */
	public void resetGate() {
		currentGate = dummyGate;
	}

	/**
	 * Sets the current gate
	 */
	public void setGate(Gate gate) {
		currentGate = gate;
	}

	public UserDevice() throws java.lang.Exception {

		state = StateTerminal.IDLE;
		pin = new Secret();

		System.setProperty("javax.net.ssl.trustStore",
				"../Generated/src/META-INF/client-truststore.jks");
		System.setProperty("javax.net.ssl.trustStorePassword", "changeit");

		System.setProperty("javax.net.ssl.keyStore",
				"../Generated/src/META-INF/client-keystore.jks");
		System.setProperty("javax.net.ssl.keyStorePassword", "changeit");

	}

	public UserDevice(byte state) throws java.lang.Exception {

		this.state = state;

		pin = new Secret();

		System.setProperty("javax.net.ssl.trustStore",
				"../Generated/src/META-INF/client-truststore.jks");
		System.setProperty("javax.net.ssl.trustStorePassword", "changeit");

		System.setProperty("javax.net.ssl.keyStore",
				"../Generated/src/META-INF/client-keystore.jks");
		System.setProperty("javax.net.ssl.keyStorePassword", "changeit");

	}

	private static void setTimeout(BindingProvider b) {
		b.getRequestContext().put("com.sun.xml.ws.request.timeout",
				new Integer(1000 * 60 * 10));
		b.getRequestContext().put("com.sun.xml.ws.connect.timeout",
				new Integer(1000 * 60 * 10));
	}

	private void sendMsg(Message msg) {

		currentGate.callConstraints();
		userinterface.send((Usermessage) msg);

	}

	private void sendMsg(Message msg, int port) throws java.lang.Exception {

		sendMsg(msg, port, false, false);

	}
	private void sendMsg(Message msg, int port, Boolean openSessionBeforeSend,
			Boolean closeSessionAfterReceive) throws java.lang.Exception {

		currentGate.callConstraints();

		Message response;

		switch (port) {
			case Ports.UserDevice2ETicketServer_default :
				if (openSessionBeforeSend) {

					ETicketServerStatefulManager managerETicketServer = new ETicketServerStatefulManagerService()
							.getETicketServerStatefulManagerPort();
					setTimeout((BindingProvider) managerETicketServer);
					ETicketServer statefulServiceETicketServer = new ETicketServerService()
							.getPort(managerETicketServer.getReference(),
									ETicketServer.class);
					setTimeout((BindingProvider) statefulServiceETicketServer);
					statefulServices.put(Integer.toString(port),
							statefulServiceETicketServer);

				}

				response = ((ETicketServer) statefulServices.get(Integer
						.toString(port))).process(new MessageWrapper(msg))
						.getMsg();

				if (closeSessionAfterReceive) {
					((ETicketServer) statefulServices.get(Integer
							.toString(port))).closeService();
				}
				processMessage(response);
				break;

			case Ports.UserDevice2ETicketCard_default :
				response = sendCardMsg(msg, port);
				if (response != null)
					processMessage(response);
				break;

			default :
				stop();
		}
	}

	private Message sendCardMsg(Message msg, int port)
			throws java.lang.Exception {
		byte[] encMsg = new byte[LengthConstants.MAX_ENCODING_LENGTH_MESSAGES];
		short encMsgLen = Coding.getInstance().encode((Codeable) msg, encMsg);
		encMsg = ByteArray.subarray(encMsg, 0, encMsgLen);
		byte[] apdu = ByteArray.append(new byte[]{0, 2, 0, 0, 0}, encMsg);
		byte[] response = currentGate.transmit(this, apdu, port);

		if (response.length == 2) {
			if (!(response[0] == (byte) 0x90 && response[1] == (byte) 0x00))
				throw new TerminalException("Cardexception: "
						+ HandleResult.interpretSW(response));
			return null;
		} else {
			prevMsg = response;

			Coding.getInstance().decodeInit();
			Codeable cResponse = Coding.getInstance().decode(response);
			return (Message) cResponse;
		}
	}

	/**
	 * Processes a raw data stream by trying to decode data to Message.
	 * Needed for testcases.
	 * @param data
	 */
	public void processRawMessage(byte[] data) {
		prevMsg = data;
		try {
			Coding.getInstance().decodeInit();
			Codeable cResponse = Coding.getInstance().decode(data);
			processMessage((Message) cResponse);
		} catch (java.lang.Exception e) {
			System.err.println("Failed decoding data in processRawMessage");
		}

	}

	private void processMessage(Message inmsg) throws java.lang.Exception {
		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.UBUYTICKET :
				processUBuyTicket((UBuyTicket) inmsg);
				break;
			case Code.REQTICKET :
				processReqTicket((ReqTicket) inmsg);
				break;
			case Code.BUYTICKETSUCCESSFUL :
				processBuyTicketSuccessful((BuyTicketSuccessful) inmsg);
				break;
			case Code.RESREQTICKET :
				processResReqTicket((ResReqTicket) inmsg);
				break;
			case Code.TICKETRECEIVED :
				processTicketReceived((TicketReceived) inmsg);
				break;
			case Code.UDELETETICKET :
				processUDeleteTicket((UDeleteTicket) inmsg);
				break;
			case Code.UHANDSHAKE :
				processUHandshake((UHandshake) inmsg);
				break;
			case Code.CLIENTHELLO :
				processClientHello((ClientHello) inmsg);
				break;
			case Code.SERVERHELLO :
				processServerHello((ServerHello) inmsg);
				break;
			case Code.HANDSHAKESUCCESSFUL :
				processHandshakeSuccessful((HandshakeSuccessful) inmsg);
				break;
			case Code.SESSIONKEY :
				processSessionKey((SessionKey) inmsg);
				break;
			case Code.URECOVERTICKET :
				processURecoverTicket((URecoverTicket) inmsg);
				break;
			case Code.REQRECOVERY :
				processReqRecovery((ReqRecovery) inmsg);
				break;
			case Code.RESREQRECOVERY :
				processResReqRecovery((ResReqRecovery) inmsg);
				break;
			case Code.RECOVERYSUCCESSFUL :
				processRecoverySuccessful((RecoverySuccessful) inmsg);
				break;
			case Code.TICKETRECEIVEDRECOVERY :
				processTicketReceivedRecovery((TicketReceivedRecovery) inmsg);
				break;
			case Code.USHOWALLTICKETS :
				processUShowAllTickets((UShowAllTickets) inmsg);
				break;
			case Code.RETURNALLTICKETS :
				processReturnAllTickets((ReturnAllTickets) inmsg);
				break;
			case Code.USETPASSWORD :
				processUSetPassword((USetPassword) inmsg);
				break;
			default :
				stop();
		}

		currentGate.callConstraints();
		currentGate.finishProtocol(this);
	}

	public void process(Message msg) throws TerminalException {
		currentGate.callConstraints();

		try {
			if (msg instanceof Usermessage)
				prevUMsg = (Usermessage) msg;
			processMessage(msg);
		} catch (java.lang.Exception e) {
			// e.printStackTrace();
			if (e instanceof TerminalException)
				throw (TerminalException) e;
			else
				throw new TerminalException(
						"Error when calling process method: " + e);
		}

		currentGate.callConstraints();
		currentGate.finishProtocol(this);
	}

	private final static int MAX_SPLIT_LENGTH = 50;
	private final static int MAX_APDU_LENGTH = 254;
	private final static int APDU_HEADER_LENGTH = 5;
	private final static int APDU_DATA_LENTH = MAX_APDU_LENGTH
			- APDU_HEADER_LENGTH;
	private SWTReader[] reader = new SWTReader[2];

	public void initReader(SWTReader reader, int port) {
		this.reader[port] = reader;
	}

	public byte[] encode(Codeable c) throws java.lang.Exception {
		byte[] encMsg = new byte[LengthConstants.MAX_ENCODING_LENGTH_MESSAGES];
		short encMsgLen = Coding.getInstance().encode(c, encMsg);
		return ByteArray.subarray(encMsg, 0, encMsgLen);
	}

	public byte[] transmit(byte[] apdu, int port) throws TerminalException,
			SWTReaderException {
		byte[] received = null;
		if (apdu.length <= MAX_APDU_LENGTH) {
			apdu[4] = (byte) (apdu.length - 5);
			received = reader[port].transmit(apdu);
			if (received.length == 2)
				return received;
			received = ByteArray.subarray(received, 0, received.length - 2);
		} else {
			byte[] splittedApdu;
			byte[] apduHeader = ByteArray.subarray(apdu, 0, APDU_HEADER_LENGTH);
			apdu = ByteArray.subarray(apdu, APDU_HEADER_LENGTH);
			int splitCount = apdu.length / APDU_DATA_LENTH;
			if (apdu.length % APDU_DATA_LENTH != 0)
				splitCount++;
			for (int i = 0; i < splitCount; i++) {
				if (i == splitCount - 1) {
					splittedApdu = ByteArray
							.subarray(apdu, i * APDU_DATA_LENTH);
					apduHeader[2] = (byte) 0;
					apduHeader[4] = (byte) splittedApdu.length;
					splittedApdu = ByteArray.append(apduHeader, splittedApdu);
					received = reader[port].transmit(splittedApdu);
					if (received.length == 2)
						return received;
					received = ByteArray.subarray(received, 0,
							received.length - 2);
				} else {
					splittedApdu = ByteArray.subarray(apdu,
							i * APDU_DATA_LENTH, APDU_DATA_LENTH);
					apduHeader[2] = (byte) 1;
					apduHeader[4] = (byte) splittedApdu.length;
					splittedApdu = ByteArray.append(apduHeader, splittedApdu);
					received = reader[port].transmit(splittedApdu);
					if (!(received[0] == (byte) 0x90 && received[1] == (byte) 0x00)) {
						throw new TerminalException(
								"Bad answer from card: part of a long APDU was not answered with OK (0x9000).");
					}
				}
			}
		}

		for (int i = 0; i < MAX_SPLIT_LENGTH; i++) {
			if (received[0] == 0) {
				received = ByteArray.subarray(received, 1);
				return received;
			} else if (received[0] == 1) {
				received = ByteArray.subarray(received, 1);
				byte[] getMore = new byte[]{0, 6, 0, 0, 0, 1, 1};
				byte[] temp_received = reader[port].transmit(getMore);

				temp_received = ByteArray.subarray(temp_received, 0,
						temp_received.length - 2);
				received = ByteArray.append(temp_received[0], received);
				temp_received = ByteArray.subarray(temp_received, 1);
				received = ByteArray.append(received, temp_received);
			} else
				throw new TerminalException(
						"Bad answer from card: answer to a long APDU must begin with 0 or 1.");
		}
		return received;
	}

	/**
	 * This method initializes the card with the given parameters that correspond 
	 * to the card attributes. A null value will be ignored by the card.
	 * @throws Exception
	 */
	public void initCard_ETicketCard(int port, CCInfo ccInfo,
			SignedData certCard, ID id, Secret pin, PrivateKey privateKeyCard,
			PublicKey publicKeyCard, PublicKey publicKeyServer, byte state)
			throws java.lang.Exception {
		byte cardCode = Code.ETICKETCARD;
		byte[] apdu = {0, 4, 0, 0, 0, cardCode};
		apdu = ByteArray.append(apdu, (ccInfo != null)
				? encode(ccInfo)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (certCard != null)
				? encode(certCard)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (id != null)
				? encode(id)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (pin != null)
				? encode(pin)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (privateKeyCard != null)
				? encode(privateKeyCard)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (publicKeyCard != null)
				? encode(publicKeyCard)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (publicKeyServer != null)
				? encode(publicKeyServer)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, new byte[]{Code.BYTE, state});
		transmit(apdu, port);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUBuyTicket(UBuyTicket inmsg) throws java.lang.Exception {
		TicketInfo ticketInfo = inmsg.getTicketInfo();
		sendMsg(new BuyTicket(ticketInfo, pin),
				Ports.UserDevice2ETicketCard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processReqTicket(ReqTicket inmsg) throws java.lang.Exception {
		EncDataSymm enc = inmsg.getMsg();
		sendMsg(new ReqTicket(enc), Ports.UserDevice2ETicketServer_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processBuyTicketSuccessful(BuyTicketSuccessful inmsg)
			throws java.lang.Exception {

		sendMsg(new UBuyTicketSuccessful());
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processResReqTicket(ResReqTicket inmsg)
			throws java.lang.Exception {
		EncDataSymm encResponse = inmsg.getMsg();
		sendMsg(new ResReqTicket(encResponse),
				Ports.UserDevice2ETicketCard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processTicketReceived(TicketReceived inmsg)
			throws java.lang.Exception {
		EncDataSymm enc = inmsg.getMsg();
		sendMsg(new TicketReceived(enc),
				Ports.UserDevice2ETicketServer_default, false, true);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUDeleteTicket(UDeleteTicket inmsg)
			throws java.lang.Exception {
		ID ticketID = inmsg.getTicketID();
		sendMsg(new DeleteTicket(pin, ticketID),
				Ports.UserDevice2ETicketCard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUHandshake(UHandshake inmsg) throws java.lang.Exception {

		sendMsg(new Handshake(), Ports.UserDevice2ETicketCard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processClientHello(ClientHello inmsg)
			throws java.lang.Exception {
		EncDataAsymm enc = inmsg.getMsg();
		SignedData certCard = inmsg.getCertCard();
		PublicKey publicKeyCard = inmsg.getPublicKeyCard();
		sendMsg(new ClientHello(enc, certCard, publicKeyCard),
				Ports.UserDevice2ETicketServer_default, true, false);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processServerHello(ServerHello inmsg)
			throws java.lang.Exception {
		EncDataAsymm enc1 = inmsg.getMsg();
		sendMsg(new ServerHello(enc1), Ports.UserDevice2ETicketCard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processHandshakeSuccessful(HandshakeSuccessful inmsg)
			throws java.lang.Exception {

		sendMsg(new UHandshakeSuccessful());
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSessionKey(SessionKey inmsg) throws java.lang.Exception {
		EncDataAsymm enc = inmsg.getMsg();
		sendMsg(new SessionKey(enc), Ports.UserDevice2ETicketServer_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processURecoverTicket(URecoverTicket inmsg)
			throws java.lang.Exception {

		sendMsg(new RecoverTicket(pin), Ports.UserDevice2ETicketCard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processReqRecovery(ReqRecovery inmsg)
			throws java.lang.Exception {
		EncDataSymm enc = inmsg.getRecoveryInfo();
		sendMsg(new ReqRecovery(enc), Ports.UserDevice2ETicketServer_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processResReqRecovery(ResReqRecovery inmsg)
			throws java.lang.Exception {
		EncDataSymm resEnc = inmsg.getRecoveryData();
		sendMsg(new ResReqRecovery(resEnc),
				Ports.UserDevice2ETicketCard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processRecoverySuccessful(RecoverySuccessful inmsg)
			throws java.lang.Exception {

		sendMsg(new URecoverySuccessful());
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processTicketReceivedRecovery(TicketReceivedRecovery inmsg)
			throws java.lang.Exception {
		EncDataSymm enc = inmsg.getMsg();
		sendMsg(new TicketReceivedRecovery(enc),
				Ports.UserDevice2ETicketServer_default, false, true);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUShowAllTickets(UShowAllTickets inmsg)
			throws java.lang.Exception {

		sendMsg(new ShowAllTickets(), Ports.UserDevice2ETicketCard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processReturnAllTickets(ReturnAllTickets inmsg)
			throws java.lang.Exception {
		ListOfTicket tickets = inmsg.getTickets();
		sendMsg(new UReturnAllTickets(tickets));
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUSetPassword(USetPassword inmsg)
			throws java.lang.Exception {
		Secret pin = inmsg.getPin();
		this.setPin(pin);
	}

	public byte getState() {
		return state;
	}

	public Secret getPin() {
		return pin;
	}

	public void setState(byte state) {
		this.state = state;
	}

	public void setPin(Secret pin) {
		this.pin = pin;
	}

	protected void stop() throws TerminalException {
		currentGate.callConstraints();
		throw new TerminalException("UserDevice");
	}

}
